<template>
  <div class="container-fluid mt-3">
    <div class="row">
      <div class="col-md-3 mb-4">
        <Category /> <!-- component category -->
      </div>
      <div class="col-md-9">
        <Slider /> <!-- Component slider -->
      </div>
    </div>
  </div>

  <div class="container-fluid mb-5 mt-4">
    <!-- header title -->
    <div class="row">
      <div class="col-12">
        <h4 class="font-weight-bold text-left mb-2">All Products</h4>
      </div>
    </div>

    <div class="row">
      <div v-for="product in products" :key="product.id" class="mb-3 col-12 col-sm-6 col-md-4 col-lg-3">
        <div class="card h-100 border-0 shadow rounded-md">
          <!-- product image -->
          <div class="card-img">
            <img :src="product.image" class="w-100"
              style="height: 15em;object-fit:cover;border-top-left-radius: .25rem;border-top-right-radius: .25rem;">
          </div>

          <div class="card-body text-left">
            <!-- product title -->
            <router-link :to="{ name: 'detail_product', params: { slug: product.slug } }"
              class="card-title font-weight-bold" style="font-size: 18px">
              {{ product.title.substring(0, 45) + ".." }}
            </router-link>

            <!-- product discount -->
            <div class="discount mt-2" style="color:#999;">
              <del class="mr-2">Rp {{ moneyFormat(product.price) }}</del>
              <span style="background-color: #2ECC71" class="badge badge-pill badge-success text-white">
                Discount {{ product.discount }} %
              </span>
            </div>

            <!-- product price -->
            <div class="price font-weight-bold mt-3" style="font-size:20px">
              Rp {{ moneyFormat(calculateDiscount(product)) }}
              <router-link :to="{ name: 'detail_product', params: { slug: product.slug } }"
                class="btn btn-primary btn-md mt-3 btn-block shadow-md border-0"> Show Product</router-link>
            </div>
          </div>
        </div>
      </div>
    </div>

  </div>
</template>

<script>
import Category from '@/components/Category.vue' // import category component
import Slider from '@/components/Slider.vue' // import slider component
import { computed, onMounted } from 'vue'
import { useStore } from 'vuex'

export default {
  components: {
    Category,
    Slider
  },

  setup() {
    // store vuex
    const store = useStore()

    // onMounted akan menjalankan action "getProducts" di module product
    onMounted(() => {
      store.dispatch('product/getProducts');
    });

    // computed properti digunakan untuk get data product dari state di module product
    const products = computed(() => {
      return store.state.product.products;
    });
    // return 
    return {
      store,
      products
    }
  }
}
</script>